<html>
<head>
<title>OGRE: OgreGpuProgram.h File Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreGpuProgram.h File Reference</h1><code>#include &quot;<a class="el" href="OgrePrerequisites_8h-source.html">OgrePrerequisites.h</a>&quot;</code><br>
<code>#include &quot;<a class="el" href="OgreResource_8h-source.html">OgreResource.h</a>&quot;</code><br>
<code>#include &quot;<a class="el" href="OgreSharedPtr_8h-source.html">OgreSharedPtr.h</a>&quot;</code><br>
<code>#include &quot;<a class="el" href="OgreIteratorWrappers_8h-source.html">OgreIteratorWrappers.h</a>&quot;</code><br>

<p>
<a href="OgreGpuProgram_8h-source.html">Go to the source code of this file.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Namespaces</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">namespace &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceOgre.html">Ogre</a></td></tr>

<tr><td colspan="2"><br><h2>Classes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1GpuConstantDefinition.html">Ogre::GpuConstantDefinition</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Information about predefined program constants.  <a href="structOgre_1_1GpuConstantDefinition.html#_details">More...</a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1GpuNamedConstants.html">Ogre::GpuNamedConstants</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Struct collecting together the information for named constants.  <a href="structOgre_1_1GpuNamedConstants.html#_details">More...</a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1GpuLogicalIndexUse.html">Ogre::GpuLogicalIndexUse</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Structure recording the use of a physical buffer by a logical parameter index.  <a href="structOgre_1_1GpuLogicalIndexUse.html#_details">More...</a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1GpuLogicalBufferStruct.html">Ogre::GpuLogicalBufferStruct</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Container struct to allow params to safely &amp; update shared list of logical buffer assignments.  <a href="structOgre_1_1GpuLogicalBufferStruct.html#_details">More...</a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">class &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuProgramParameters.html">Ogre::GpuProgramParameters</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Collects together the program parameters used for a <a class="el" href="classOgre_1_1GpuProgram.html" title="Defines a program which runs on the GPU such as a vertex or fragment program.">GpuProgram</a>.  <a href="classOgre_1_1GpuProgramParameters.html#_details">More...</a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1GpuProgramParameters_1_1AutoConstantDefinition.html">Ogre::GpuProgramParameters::AutoConstantDefinition</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Structure defining an auto constant that's available for use in a parameters object.  <a href="structOgre_1_1GpuProgramParameters_1_1AutoConstantDefinition.html#_details">More...</a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">class &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuProgramParameters_1_1AutoConstantEntry.html">Ogre::GpuProgramParameters::AutoConstantEntry</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Structure recording the use of an automatic parameter.  <a href="classOgre_1_1GpuProgramParameters_1_1AutoConstantEntry.html#_details">More...</a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">class &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuProgram.html">Ogre::GpuProgram</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Defines a program which runs on the GPU such as a vertex or fragment program.  <a href="classOgre_1_1GpuProgram.html#_details">More...</a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">class &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuProgram_1_1CmdType.html">Ogre::GpuProgram::CmdType</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Command object - see <a class="el" href="classOgre_1_1ParamCommand.html" title="Abstract class which is command object which gets/sets parameters.">ParamCommand</a>.  <a href="classOgre_1_1GpuProgram_1_1CmdType.html#_details">More...</a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">class &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuProgram_1_1CmdSyntax.html">Ogre::GpuProgram::CmdSyntax</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">class &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuProgram_1_1CmdSkeletal.html">Ogre::GpuProgram::CmdSkeletal</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">class &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuProgram_1_1CmdMorph.html">Ogre::GpuProgram::CmdMorph</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">class &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuProgram_1_1CmdPose.html">Ogre::GpuProgram::CmdPose</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">class &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuProgram_1_1CmdVTF.html">Ogre::GpuProgram::CmdVTF</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">class &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuProgramPtr.html">Ogre::GpuProgramPtr</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Specialisation of <a class="el" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">SharedPtr</a> to allow <a class="el" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">SharedPtr</a> to be assigned to <a class="el" href="classOgre_1_1GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GpuProgramPtr.">GpuProgramPtr</a>.  <a href="classOgre_1_1GpuProgramPtr.html#_details">More...</a><br></td></tr>
<tr><td colspan="2"><br><h2>Typedefs</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::map<br>
&lt; String,<br>
 GpuConstantDefinition &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceOgre.html#e4823c1377e5d4c312a3da9d1cb8534a">Ogre::GpuConstantDefinitionMap</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef <br>
ConstMapIterator<br>
&lt; GpuConstantDefinitionMap &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceOgre.html#ff7bf5891ea6cfed80f4e50edc5d3695">Ogre::GpuConstantDefinitionIterator</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::map<br>
&lt; size_t,<br>
 GpuLogicalIndexUse &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceOgre.html#a51ba56cbce3f845ffd4be59ec30fd83">Ogre::GpuLogicalIndexUseMap</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef SharedPtr<br>
&lt; GpuProgramParameters &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceOgre.html#ebab7cecf3f3ae81a1fbfa08ab36f2b5">Ogre::GpuProgramParametersSharedPtr</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Shared pointer used to hold references to <a class="el" href="classOgre_1_1GpuProgramParameters.html" title="Collects together the program parameters used for a GpuProgram.">GpuProgramParameters</a> instances.  <a href="#ebab7cecf3f3ae81a1fbfa08ab36f2b5"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Enumerations</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">enum &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceOgre.html#d08e89fa63e81d061ea9e2f37664976e">Ogre::GpuProgramType</a> { <a class="el" href="namespaceOgre.html#d08e89fa63e81d061ea9e2f37664976e3d96c54ace718f26c66067503efd56a3">Ogre::GPT_VERTEX_PROGRAM</a>, 
<a class="el" href="namespaceOgre.html#d08e89fa63e81d061ea9e2f37664976ec9a00b013e9075bc061b0585cf9a6c3b">Ogre::GPT_FRAGMENT_PROGRAM</a>
 }</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Enumerates the types of programs which can run on the GPU.  <a href="namespaceOgre.html#d08e89fa63e81d061ea9e2f37664976e">More...</a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">enum &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceOgre.html#9c5b2950be06ff56a6ee0bace240d447">Ogre::GpuConstantType</a> { <br>
&nbsp;&nbsp;<a class="el" href="namespaceOgre.html#9c5b2950be06ff56a6ee0bace240d4472e6d0cad211d29d14774e0ca147dcd30">Ogre::GCT_FLOAT1</a>, 
<a class="el" href="namespaceOgre.html#9c5b2950be06ff56a6ee0bace240d447979f39c4955889813f82374df96f6181">Ogre::GCT_FLOAT2</a>, 
<a class="el" href="namespaceOgre.html#9c5b2950be06ff56a6ee0bace240d447bf2aed5efd251c030794ec27a7174fc8">Ogre::GCT_FLOAT3</a>, 
<a class="el" href="namespaceOgre.html#9c5b2950be06ff56a6ee0bace240d447466febc90367dab6c895c98edfff7681">Ogre::GCT_FLOAT4</a>, 
<br>
&nbsp;&nbsp;<a class="el" href="namespaceOgre.html#9c5b2950be06ff56a6ee0bace240d44799d7d2b7976d0ef3b940f01e017b54ed">Ogre::GCT_SAMPLER1D</a>, 
<a class="el" href="namespaceOgre.html#9c5b2950be06ff56a6ee0bace240d4474f4eec3ce315c9a1ed97f47689241b64">Ogre::GCT_SAMPLER2D</a>, 
<a class="el" href="namespaceOgre.html#9c5b2950be06ff56a6ee0bace240d44718d1b343f2ec603945d3d7875622637a">Ogre::GCT_SAMPLER3D</a>, 
<a class="el" href="namespaceOgre.html#9c5b2950be06ff56a6ee0bace240d44713e953e084eb700f0bf55a42f6cae138">Ogre::GCT_SAMPLERCUBE</a>, 
<br>
&nbsp;&nbsp;<a class="el" href="namespaceOgre.html#9c5b2950be06ff56a6ee0bace240d44737ce33389359aac73400ae427d9920fa">Ogre::GCT_SAMPLER1DSHADOW</a>, 
<a class="el" href="namespaceOgre.html#9c5b2950be06ff56a6ee0bace240d447cea2c4e9feb93413f97ce9c045269a50">Ogre::GCT_SAMPLER2DSHADOW</a>, 
<a class="el" href="namespaceOgre.html#9c5b2950be06ff56a6ee0bace240d4470b2767a1b36c8e7821979adb15615c7a">Ogre::GCT_MATRIX_2X2</a>, 
<a class="el" href="namespaceOgre.html#9c5b2950be06ff56a6ee0bace240d447bd03cb2cf3acde19f3a348e6146dd3e9">Ogre::GCT_MATRIX_2X3</a>, 
<br>
&nbsp;&nbsp;<a class="el" href="namespaceOgre.html#9c5b2950be06ff56a6ee0bace240d447964c921cd7327eb271da6eb78742a850">Ogre::GCT_MATRIX_2X4</a>, 
<a class="el" href="namespaceOgre.html#9c5b2950be06ff56a6ee0bace240d44780cbab72631a6efe3feaed44bf01e97e">Ogre::GCT_MATRIX_3X2</a>, 
<a class="el" href="namespaceOgre.html#9c5b2950be06ff56a6ee0bace240d4470128d0683a17c232bb249a068c65cbd7">Ogre::GCT_MATRIX_3X3</a>, 
<a class="el" href="namespaceOgre.html#9c5b2950be06ff56a6ee0bace240d44787a7bc0df0623b02534894a90d634f6d">Ogre::GCT_MATRIX_3X4</a>, 
<br>
&nbsp;&nbsp;<a class="el" href="namespaceOgre.html#9c5b2950be06ff56a6ee0bace240d44733f4e8ee7271ce5353aa53c04c18447d">Ogre::GCT_MATRIX_4X2</a>, 
<a class="el" href="namespaceOgre.html#9c5b2950be06ff56a6ee0bace240d4475b26aaa1925eaa7bb83dd4a9e25b28d5">Ogre::GCT_MATRIX_4X3</a>, 
<a class="el" href="namespaceOgre.html#9c5b2950be06ff56a6ee0bace240d44701541907f48e2d56b7198a4076996a43">Ogre::GCT_MATRIX_4X4</a>, 
<a class="el" href="namespaceOgre.html#9c5b2950be06ff56a6ee0bace240d447d023a5c54e29999cee04d54971cc5691">Ogre::GCT_INT1</a>, 
<br>
&nbsp;&nbsp;<a class="el" href="namespaceOgre.html#9c5b2950be06ff56a6ee0bace240d447fce84063333829487cd0401fca732092">Ogre::GCT_INT2</a>, 
<a class="el" href="namespaceOgre.html#9c5b2950be06ff56a6ee0bace240d44718edb505f8205cfed6bb28da3abefd53">Ogre::GCT_INT3</a>, 
<a class="el" href="namespaceOgre.html#9c5b2950be06ff56a6ee0bace240d447278c0c55560cb39e67ce17239dc8184e">Ogre::GCT_INT4</a>, 
<a class="el" href="namespaceOgre.html#9c5b2950be06ff56a6ee0bace240d4473b3c9d05e75e6c20fd106d0f0080ad7e">Ogre::GCT_UNKNOWN</a>
<br>
 }</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Enumeration of the types of constant we may encounter in programs.  <a href="namespaceOgre.html#9c5b2950be06ff56a6ee0bace240d447">More...</a><br></td></tr>
</table>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:58 2008
</p>
</body>
</html>
